SystemOrganization addCategory: #'FRP-Kernel'!
SystemOrganization addCategory: #'FRP-Tests'!

Morph subclass: #FRPTimer
	instanceVariableNames: 'state interval anyButtonPressed time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPTimer methodsFor: 'accessing' stamp: 'zz 5/16/2008 13:23'!
anyButtonPressed
	^ anyButtonPressed! !

!FRPTimer methodsFor: 'event handling' stamp: 'zz 5/16/2008 13:23'!
handlesMouseDown: event 
	^ true! !

!FRPTimer methodsFor: 'initialization' stamp: 'zz 5/16/2008 13:28'!
initialize
	super initialize.
	state := #stopped.
	interval := 1000.
	anyButtonPressed := false! !

!FRPTimer methodsFor: 'accessing' stamp: 'zz 5/14/2008 13:58'!
interval: anInterval 
	interval := anInterval! !

!FRPTimer methodsFor: 'testing' stamp: 'zz 5/14/2008 13:58'!
isRunning
	^ state == #run! !

!FRPTimer methodsFor: 'event handling' stamp: 'zz 5/16/2008 13:23'!
mouseDown: anEvent 
	anEvent anyButtonPressed
		ifTrue: [anyButtonPressed := true]! !

!FRPTimer methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 13:58'!
startTimer
	state := #run! !

!FRPTimer methodsFor: 'stepping and presenter' stamp: 'zz 5/16/2008 15:48'!
step
	self isRunning
		ifTrue: [time eventOccured]! !

!FRPTimer methodsFor: 'accessing' stamp: 'zz 5/14/2008 13:58'!
stepTime
	^ interval! !

!FRPTimer methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 13:58'!
stopTimer
	state := #stopped! !

!FRPTimer methodsFor: 'accessing' stamp: 'zz 5/28/2008 18:14'!
time: anFRPTimeObject 
	time := anFRPTimeObject! !

TestCase subclass: #FRPAbstractBehaviorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Tests'!

!FRPAbstractBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:56'!
testFourDivideTwoEqualsTwo
	| four two result |
	four := 4 asFRPConstantBehavior.
	two := 2 asFRPConstantBehavior.
	result := four / two.
	self assert: result behaviorValue = 2! !

!FRPAbstractBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:56'!
testFourDivideTwoEqualsTwoTwice
	| four two result |
	four := 4 asFRPConstantBehavior.
	two := 2 asFRPConstantBehavior.
	result := four / two.
	self assert: result behaviorValue = 2.
	self assert: result behaviorValue = 2! !

!FRPAbstractBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:56'!
testOneIsLessOrEqualThanOne
	| one result |
	one := 1 asFRPConstantBehavior.
	result := one <= one.
	self assert: result event = true! !

!FRPAbstractBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:56'!
testOneIsNotGreaterThanOne
	| one result |
	one := 1 asFRPConstantBehavior.
	result := one > one.
	self assert: result event = false! !

!FRPAbstractBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:56'!
testOnePlusOneIsGreaterOrEqualThanOne
	| one two result |
	one := 1 asFRPConstantBehavior.
	two := one + one.
	result := two >= one.
	self assert: result event = true! !

!FRPAbstractBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:57'!
testOnePlusTwoEqualsThree
	| one two result |
	one := 1 asFRPConstantBehavior.
	two := 2 asFRPConstantBehavior.
	result := one + two.
	self assert: result behaviorValue = 3! !

!FRPAbstractBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:57'!
testTwoBehaviorsWithTheSameValueAreEquals
	| b1 b2 |
	b1 := (1 + 1) asFRPConstantBehavior.
	b2 := 2 asFRPConstantBehavior.
	self assert: (b1 = b2) event = true! !

!FRPAbstractBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:57'!
testTwoIsGreaterThanOne
	| one two result |
	one := 1 asFRPConstantBehavior.
	two := 2 asFRPConstantBehavior.
	result := two > one.
	self assert: result event = true! !

!FRPAbstractBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:57'!
testTwoMinusOneEqualsOne
	| one two result |
	one := 1 asFRPConstantBehavior.
	two := 2 asFRPConstantBehavior.
	result := two - one.
	self assert: result behaviorValue = 1! !

!FRPAbstractBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:57'!
testTwoMultiplyByThreeEqualsSix
	| two three result |
	two := 2 asFRPConstantBehavior.
	three := 3 asFRPConstantBehavior.
	result := two * three.
	self assert: result behaviorValue = 6! !

TestCase subclass: #FRPBindEvenSourceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Tests'!

!FRPBindEvenSourceTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:57'!
testFireEventSourceCreateNewBindingEvent
	| e eventSource |
	e := FRPDefaultEventSource new.
	eventSource := e -=> Color red.
	e event: nil.
	self assert: eventSource event = Color red! !

!FRPBindEvenSourceTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:57'!
testNotFireEventSourceCreateNoBindingEvent
	| e eventSource |
	e := FRPDefaultEventSource new.
	eventSource := e -=> Color red.
	self assert: eventSource event = nil! !

!FRPBindEvenSourceTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:58'!
testTheResultIsAConstantValue
	| e eventSource e1 e2 |
	e := FRPDefaultEventSource new.
	eventSource := e -=> Color red.
	e event: nil.
	e1 := eventSource event.
	e event: nil.
	e2 := eventSource event.
	self assert: e1 = e2! !

TestCase subclass: #FRPConstantBehaviorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Tests'!

!FRPConstantBehaviorTest methodsFor: 'tests' stamp: 'zz 5/19/2008 14:28'!
testFRPConstantBehaviorCantBeChanged
	| b |
	b := 0 asFRPConstantBehavior.
	self
		should: [b behaviorValue: 1]
		raise: Error! !

!FRPConstantBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:58'!
testFRPConstantBehaviorDoesNotChanged
	| b |
	b := 0 asFRPConstantBehavior.
	self
		assert: b behaviorValue = b behaviorValue! !

TestCase subclass: #FRPDefaultBehaviorTest
	instanceVariableNames: 'success'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Tests'!

!FRPDefaultBehaviorTest methodsFor: 'running' stamp: 'zz 5/14/2008 15:11'!
setUp
	super setUp.
	success := false! !

!FRPDefaultBehaviorTest methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 15:11'!
succeeded
	success := true! !

!FRPDefaultBehaviorTest methodsFor: 'tests' stamp: 'zz 5/14/2008 15:12'!
testABehaviorShouldTriggerAChangedValueEventWhenChanged
	| b |
	b := FRPDefaultBehavior new.
	b
		when: #changedValue
		send: #succeeded
		to: self.
	b behaviorValue: 1.
	self should:[success]! !

!FRPDefaultBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 8/3/2009 14:47'!
testWhenABehaviorValueDoesNotChangeNoChangedValueEventIsTriggered
	| b |
	b := FRPDefaultBehavior new.
	b behaviorValue: 1.
	b
		when: #changedValue
		send: #succeeded
		to: self.
	b behaviorValue: 1.
	self
		should: [success not]! !

TestCase subclass: #FRPIntegralBehaviorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Tests'!

!FRPIntegralBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 8/6/2009 10:35'!
test1
	"| v t i |
	v := 4 asFRPConstantBehavior.
	t := FRPTime new.
	i := FRPIntegralBehavior new target: v;
				 timeSource: t;
				 sampleTime: 10.
	t start"! !

TestCase subclass: #FRPLiftBehaviorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Tests'!

!FRPLiftBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:58'!
test3After1
	| b |
	b := 1 asFRPConstantBehavior lift0: [ 3 ].
	self assert: b behaviorValue == 3! !

!FRPLiftBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:58'!
testOnePlusOneEqualsTwo
	| b |
	b := 1 asFRPConstantBehavior lift1: [ :x | x + 1 ].
	self assert: b behaviorValue == 2! !

!FRPLiftBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 09:59'!
testTwoSquaredEqualsFour
	| b |
	b := 2 asFRPConstantBehavior lift1: [ :x | x * x ].
	self assert: b behaviorValue == 4! !

!FRPLiftBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 10:02'!
testWhenChangingTheBehaviorTheLift1BehaviorChange
	| b c |
	b := FRPDefaultBehavior new.
	b behaviorValue: 1.
	c := b lift1: [ :x | x + 1 ].
	self assert: c behaviorValue == 2.
	b behaviorValue: 2.
	self assert: c behaviorValue == 3! !

TestCase subclass: #FRPMergeEventSourceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Tests'!

!FRPMergeEventSourceTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 10:03'!
test1
	| m e1 e2 b1 b2 |
	e1 := FRPDefaultEventSource new.
	e2 := FRPDefaultEventSource new.
	b1 := e1 -=> Color red.
	b2 := e2 -=> Color blue.
	m := b1 <=> b2.
	e1 event: nil.
	self assert: m event = Color red! !

!FRPMergeEventSourceTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 10:03'!
test2
	| m e1 e2 b1 b2 |
	e1 := FRPDefaultEventSource new.
	e2 := FRPDefaultEventSource new.
	b1 := e1 -=> Color red.
	b2 := e2 -=> Color blue.
	m := b1 <=> b2.
	e2 event: nil.
	self assert: m event = Color blue! !

!FRPMergeEventSourceTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 10:03'!
test3
	| m e1 e2 b1 b2 |
	e1 := FRPDefaultEventSource new.
	e2 := FRPDefaultEventSource new.
	b1 := e1 -=> Color red.
	b2 := e2 -=> Color blue.
	m := b1 <=> b2.
	e2 event: nil.
	e2 event: nil.
	self assert: m event = Color blue! !

TestCase subclass: #FRPStepperBehaviorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Tests'!

!FRPStepperBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 10:03'!
testStepperAfterFirstEventReturnsFirstEventValue
	| b e stepper |
	b := 0 asFRPConstantBehavior.
	e := FRPDefaultEventSource new.
	stepper := b step: e.
	e event: 1.
	self assert: stepper behaviorValue = e event! !

!FRPStepperBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 10:03'!
testStepperReturnsInitialBehaviorBeforeFirstEvent
	| b e stepper |
	b := 0 asFRPConstantBehavior.
	e := FRPDefaultEventSource new.
	stepper := b step: e.
	self assert: stepper behaviorValue == b! !

TestCase subclass: #FRPSwitcherBehaviorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Tests'!

!FRPSwitcherBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 10:04'!
testOneEvent
	"c = switcher red (lbp -=> red .|. rbp -=> blue)"

	| e1 e2 m1 c |
	e1 := FRPDefaultEventSource new.
	e2 := FRPDefaultEventSource new.
	m1 := e1 -=> Color red <=> (e2 -=> Color blue).
	c := (FRPSwitcherBehavior new)
		initialBehavor: Color red;
		eventSource: m1.
	e1 event: nil.
	self assert: c behaviorValue = Color red! !

!FRPSwitcherBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 10:04'!
testTwoDifferentEvent
	"c = switcher red (lbp -=> red .|. rbp -=> blue)"

	| e1 e2 m1 c |
	e1 := FRPDefaultEventSource new.
	e2 := FRPDefaultEventSource new.
	m1 := e1 -=> Color red <=> (e2 -=> Color blue).
	c := (FRPSwitcherBehavior new)
		initialBehavor: Color red;
		eventSource: m1.
	e1 event: nil.
	e2 event: nil.
	self assert: c behaviorValue = Color blue! !

!FRPSwitcherBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 10:04'!
testTwoSameEvent
	"c = switcher red (lbp -=> red .|. rbp -=> blue)"

	| e1 e2 m1 c |
	e1 := FRPDefaultEventSource new.
	e2 := FRPDefaultEventSource new.
	m1 := e1 -=> Color red <=> (e2 -=> Color blue).
	c := (FRPSwitcherBehavior new)
		initialBehavor: Color red;
		eventSource: m1.
	e1 event: nil.
	e1 event: nil.
	self assert: c behaviorValue = Color red! !

TestCase subclass: #FRPUntilBehaviorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Tests'!

!FRPUntilBehaviorTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 10:06'!
test1
	| one two u e f |
	one := 1 asFRPConstantBehavior.
	two := 2 asFRPConstantBehavior.
	e := FRPDefaultEventSource new.
	f := e -=> two.
	u := (FRPUntilBehavior new)
		behavior: one;
		eventSource: f.
	self assert: u behaviorValue == one.
	e event: nil.
	self assert: u behaviorValue == two! !

TestCase subclass: #FRPWhenEventSourceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Tests'!

!FRPWhenEventSourceTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 10:05'!
test1
	| b w e |
	b := true asFRPConstantBehavior.
	e := FRPDefaultEventSource new.
	w := (FRPWhenEventSource new)
		eventSource: e;
		condition: b.
	e event: 1.
	self assert: w event = 1! !

!FRPWhenEventSourceTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/4/2010 10:05'!
test2
	| b w e |
	b := false asFRPConstantBehavior.
	e := FRPDefaultEventSource new.
	w := (FRPWhenEventSource new)
		eventSource: e;
		condition: b.
	e event: 1.
	self assert: w event = nil! !

Object subclass: #FRPObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPObject commentStamp: 'zz 5/16/2008 13:08' prior: 0!
FRPObjects handle events with MessageSend and not WeakMessageSend.!

FRPObject subclass: #FRPAbstractBehavior
	instanceVariableNames: 'behaviorValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPAbstractBehavior methodsFor: 'comparing' stamp: 'zz 5/20/2008 15:38'!
* anotherBehavior 
	^ self
		lift1: [:b | b * anotherBehavior behaviorValue]! !

!FRPAbstractBehavior methodsFor: 'comparing' stamp: 'zz 5/20/2008 15:39'!
+ anotherBehavior 
	^ self
		lift1: [:b | b + anotherBehavior behaviorValue]! !

!FRPAbstractBehavior methodsFor: 'comparing' stamp: 'zz 5/20/2008 15:39'!
- anotherBehavior 
	^ self
		lift1: [:b | b - anotherBehavior behaviorValue]! !

!FRPAbstractBehavior methodsFor: 'comparing' stamp: 'zz 5/20/2008 15:39'!
/ anotherBehavior 
	^ self
		lift1: [:b | b / anotherBehavior behaviorValue]! !

!FRPAbstractBehavior methodsFor: 'comparing' stamp: 'zz 5/28/2008 18:10'!
<= anotherBehavior 
	^ FRPAbstractEventSource new event: self behaviorValue <= anotherBehavior behaviorValue! !

!FRPAbstractBehavior methodsFor: 'comparing' stamp: 'zz 5/28/2008 15:32'!
= anotherBehavior 
	^ FRPAbstractEventSource new event: self behaviorValue = anotherBehavior behaviorValue! !

!FRPAbstractBehavior methodsFor: 'comparing' stamp: 'zz 5/28/2008 15:14'!
> anotherBehavior 
	^ FRPAbstractEventSource new event: self behaviorValue > anotherBehavior behaviorValue! !

!FRPAbstractBehavior methodsFor: 'comparing' stamp: 'zz 5/28/2008 18:10'!
>= anotherBehavior 
	^ FRPAbstractEventSource new event: self behaviorValue >= anotherBehavior behaviorValue! !

!FRPAbstractBehavior methodsFor: 'accessing' stamp: 'zz 5/14/2008 14:26'!
behaviorValue
	^ behaviorValue! !

!FRPAbstractBehavior methodsFor: 'accessing' stamp: 'zz 5/14/2008 14:26'!
behaviorValue: aBehaviorValue 
	self subclassResponsibility! !

!FRPAbstractBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 14:26'!
initialBehaviorValue: aValue 
	behaviorValue := aValue! !

!FRPAbstractBehavior methodsFor: 'combinators' stamp: 'zz 5/19/2008 15:50'!
lift0: aFunctionBlock 
	^ FRPLift0Behavior new liftedBehavior: self;
		 functionBlock: aFunctionBlock! !

!FRPAbstractBehavior methodsFor: 'combinators' stamp: 'zz 5/16/2008 16:10'!
lift1: aFunctionBlock 
	^ FRPLift1Behavior new liftedBehavior: self;
		 functionBlock: aFunctionBlock! !

!FRPAbstractBehavior methodsFor: 'combinators' stamp: 'zz 5/19/2008 13:34'!
step: anEventSource 
	^ FRPStepperBehavior new initialBehaviorValue: self;
		 eventSource: anEventSource! !

FRPAbstractBehavior subclass: #FRPConstantBehavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPConstantBehavior commentStamp: 'zz 5/9/2008 11:39' prior: 0!
A Behavior whose value never changes!

!FRPConstantBehavior methodsFor: 'accessing' stamp: 'zz 5/28/2008 18:16'!
behaviorValue: aBehaviorValue 
	^ self shouldNotImplement! !

FRPAbstractBehavior subclass: #FRPDefaultBehavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPDefaultBehavior methodsFor: 'accessing' stamp: 'SergeStinckwich 8/3/2009 14:50'!
behaviorValue: aValue 
	aValue == behaviorValue
		ifFalse: [behaviorValue := aValue.
			self triggerEvent: #changedValue]! !

!FRPDefaultBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/28/2008 13:18'!
recomputeValue
	self subclassResponsibility! !

FRPDefaultBehavior subclass: #FRPIntegralBehavior
	instanceVariableNames: 'sampleTime target timeSource prevTime accumulatorValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPIntegralBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/28/2008 13:56'!
eventOccured: anEvent 
	| newTime deltaT targetValue |
	Transcript show: 'Integral tick'.
	newTime := anEvent behaviorValue.
	deltaT := newTime - prevTime.
	targetValue := target behaviorValue.
	accumulatorValue := accumulatorValue + (targetValue * deltaT).
	self behaviorValue: accumulatorValue.
	prevTime := newTime! !

!FRPIntegralBehavior methodsFor: 'initialization' stamp: 'zz 5/28/2008 14:12'!
initialize
	super initialize.
	accumulatorValue := 0.
	prevTime := 0! !

!FRPIntegralBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/28/2008 13:26'!
recomputeValue
	timeSource behaviorValue! !

!FRPIntegralBehavior methodsFor: 'accessing' stamp: 'zz 5/28/2008 13:43'!
sampleTime: anInteger 
	sampleTime := anInteger! !

!FRPIntegralBehavior methodsFor: 'accessing' stamp: 'zz 5/28/2008 13:40'!
target: aBehavior 
	target := aBehavior! !

!FRPIntegralBehavior methodsFor: 'accessing' stamp: 'zz 5/28/2008 14:12'!
timeSource: aBehavior 
	timeSource := aBehavior.
	timeSource
		when: #changedValue
		send: #eventOccured:
		to: self! !

FRPDefaultBehavior subclass: #FRPLiftBehavior
	instanceVariableNames: 'functionBlock liftedBehavior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

FRPLiftBehavior subclass: #FRPLift0Behavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPLift0Behavior methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 15:53'!
eventOccured
	self behaviorValue: functionBlock value! !

FRPLiftBehavior subclass: #FRPLift1Behavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPLift1Behavior methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 15:53'!
eventOccured
	self
		behaviorValue: (functionBlock value: liftedBehavior behaviorValue)! !

!FRPLiftBehavior methodsFor: 'accessing' stamp: 'zz 5/19/2008 15:53'!
functionBlock: aBlock 
	functionBlock := aBlock.
	self eventOccured! !

!FRPLiftBehavior methodsFor: 'accessing' stamp: 'zz 5/19/2008 15:54'!
liftedBehavior: aBehavior 
	liftedBehavior := aBehavior.
	liftedBehavior
		when: #changedValue
		send: #eventOccured
		to: self! !

!FRPLiftBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 15:54'!
recomputeValue
	liftedBehavior behaviorValue! !

FRPDefaultBehavior subclass: #FRPStepperBehavior
	instanceVariableNames: 'eventSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPStepperBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 15:34'!
eventOccured: anEvent
	self behaviorValue: eventSource event! !

!FRPStepperBehavior methodsFor: 'accessing' stamp: 'zz 5/19/2008 15:38'!
eventSource: anEventSource 
	eventSource := anEventSource.
	eventSource
		when: #FRPEventOccured
		send: #eventOccured:
		to: self! !

!FRPStepperBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 13:15'!
recomputeValue
	eventSource event! !

FRPDefaultBehavior subclass: #FRPSwitcherBehavior
	instanceVariableNames: 'eventSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPSwitcherBehavior methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 11:17'!
eventOccured: anEvent 
	self behaviorValue: eventSource event! !

!FRPSwitcherBehavior methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 11:13'!
eventSource: anEventSource 
	eventSource := anEventSource.
	eventSource
		when: #FRPEventOccured
		send: #eventOccured:
		to: self! !

!FRPSwitcherBehavior methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 11:18'!
initialBehavor: aBehavior 
	self behaviorValue: aBehavior! !

!FRPSwitcherBehavior methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 11:16'!
recomputeValue
	eventSource event! !

FRPDefaultBehavior subclass: #FRPTime
	instanceVariableNames: 'timer samplingInterval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPTime methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 14:27'!
eventOccured
	| scheduler |
	scheduler := FRPScheduler currentScheduler.
	scheduler beginInputStep.
	self behaviorValue: behaviorValue + (samplingInterval / 1000).
	scheduler endInputStep! !

!FRPTime methodsFor: 'initialization' stamp: 'zz 5/16/2008 15:47'!
initialize
	super initialize.
	timer := FRPTimer new.
	samplingInterval := 1000.
	behaviorValue := 0.
	timer interval: samplingInterval.
	timer time: self! !

!FRPTime methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 13:50'!
recomputeValue
! !

!FRPTime methodsFor: 'accessing' stamp: 'zz 5/28/2008 13:44'!
start
	timer startTimer.
	timer openInHand! !

!FRPTime methodsFor: 'accessing' stamp: 'zz 5/28/2008 13:44'!
stop
	timer stop! !

FRPDefaultBehavior subclass: #FRPUntilBehavior
	instanceVariableNames: 'behavior eventSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPUntilBehavior methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 16:13'!
behavior: aBehavior 
	behaviorValue := aBehavior! !

!FRPUntilBehavior methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 16:13'!
eventOccured: anEvent
	self behaviorValue: anEvent  ! !

!FRPUntilBehavior methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 16:12'!
eventSource: anEvent 
	eventSource := anEvent! !

!FRPUntilBehavior methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 16:02'!
recomputeValue
	! !

FRPObject subclass: #FRPAbstractEventSource
	instanceVariableNames: 'scheduler occurence cacheTimeStep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPAbstractEventSource classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/20/2008 15:41'!
new
	^ super new scheduler: FRPScheduler currentScheduler! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 15:36'!
-=> aValue 
	"Bind combinator"
	^ FRPBindEventSource eventSource: self bind: aValue! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 10:11'!
<=> aValue 
	"Merge combinator"
	^ FRPMergeEventSource new firstEventSource: self;
		 secondEventSource: aValue! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 13:16'!
==> aBlock
! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 15:36'!
event
	scheduler currentTimeStep ~= cacheTimeStep
		ifTrue: [occurence := nil.
			cacheTimeStep := scheduler currentTimeStep.
			self recomputeOccurence].
	^ occurence! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 10:34'!
event: anEvent 
	occurence := anEvent.
	cacheTimeStep := scheduler currentTimeStep.
	self triggerEvent: #FRPEventOccured with: anEvent! !

!FRPAbstractEventSource methodsFor: 'initialization' stamp: 'zz 5/19/2008 16:27'!
initialize
	super initialize.
	occurence := nil.
	cacheTimeStep := -1! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 15:36'!
recomputeOccurence
	self subclassResponsibility! !

!FRPAbstractEventSource methodsFor: 'accessing' stamp: 'zz 5/19/2008 15:36'!
scheduler: aScheduler 
	scheduler := aScheduler! !

FRPAbstractEventSource subclass: #FRPAbstractEventSourceListener
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPAbstractEventSourceListener methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 15:36'!
eventOccured: anEvent 
	self subclassResponsibility! !

FRPAbstractEventSourceListener subclass: #FRPBindEventSource
	instanceVariableNames: 'eventSource bindValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPBindEventSource classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/20/2008 15:41'!
eventSource: anEventSource bind: aBindValue 
	^ super new eventSource: anEventSource;
		 bindValue: aBindValue! !

!FRPBindEventSource methodsFor: 'accessing' stamp: 'zz 5/19/2008 15:37'!
bindValue: aValue 
	bindValue := aValue! !

!FRPBindEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 18:02'!
eventOccured: anEvent 
	self
		event: bindValue! !

!FRPBindEventSource methodsFor: 'accessing' stamp: 'zz 5/19/2008 18:00'!
eventSource: anFRPSourceEvent 
	eventSource := anFRPSourceEvent.
	eventSource
		when: #FRPEventOccured
		send: #eventOccured:
		to: self! !

!FRPBindEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 15:37'!
recomputeOccurence
	eventSource event! !

FRPAbstractEventSourceListener subclass: #FRPBindFunctionEventSource
	instanceVariableNames: 'eventSource blockFunction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPBindFunctionEventSource methodsFor: 'accessing' stamp: 'zz 5/19/2008 16:15'!
blockFunction: aBlock
	blockFunction := aBlock! !

!FRPBindFunctionEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 16:15'!
eventOccured: anEvent 
	self
		event: (FRPObjectEvent
				withValue: (blockFunction value: anEvent))! !

!FRPBindFunctionEventSource methodsFor: 'accessing' stamp: 'zz 5/19/2008 17:53'!
eventSource: anFRPSourceEvent 
	eventSource := anFRPSourceEvent.
	eventSource
		when: #FRPEventOccured
		send: #eventOccured:
		to: self! !

!FRPBindFunctionEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 16:13'!
recomputeOccurence
	eventSource event! !

FRPAbstractEventSourceListener subclass: #FRPMergeEventSource
	instanceVariableNames: 'firstEventSource secondEventSource lastOccurenceTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPMergeEventSource classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/20/2008 15:41'!
between: firstEventSource and: secondEventSource 
	^ super new firstEventSource: firstEventSource;
		 secondEventSource: secondEventSource! !

!FRPMergeEventSource methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 13:54'!
eventOccured: anEvent 
	"scheduler currentTimeStep = lastOccurenceTime
		ifTrue: [self error: 'EventMerge: got a simultaneous occurence in this time step (dropping occurence)']
		ifFalse: [lastOccurenceTime := scheduler currentTimeStep.
			self event: anEvent]"
		
	self event: anEvent! !

!FRPMergeEventSource methodsFor: 'accessing' stamp: 'SergeStinckwich 8/5/2009 18:06'!
firstEventSource: anEventSource 
	firstEventSource := anEventSource.
	firstEventSource 
		when: #FRPEventOccured
		send: #eventOccured:
		to: self! !

!FRPMergeEventSource methodsFor: 'initialization' stamp: 'zz 5/19/2008 16:27'!
initialize
	super initialize.
	lastOccurenceTime := -1! !

!FRPMergeEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 16:02'!
recomputeOccurence
	firstEventSource event.
	secondEventSource event! !

!FRPMergeEventSource methodsFor: 'accessing' stamp: 'SergeStinckwich 8/5/2009 18:06'!
secondEventSource: anEventSource 
	secondEventSource := anEventSource.
	secondEventSource 
		when: #FRPEventOccured
		send: #eventOccured:
		to: self! !

FRPAbstractEventSourceListener subclass: #FRPWhenEventSource
	instanceVariableNames: 'eventSource conditionBehavior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPWhenEventSource methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 14:48'!
condition: aBehavior 
	conditionBehavior := aBehavior! !

!FRPWhenEventSource methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 14:48'!
eventOccured: anEvent 
	conditionBehavior behaviorValue
		ifTrue: [self event: anEvent]! !

!FRPWhenEventSource methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 14:39'!
eventSource: anEvent 
	eventSource := anEvent.
	eventSource  
		when: #FRPEventOccured
		send: #eventOccured:
		to: self! !

!FRPWhenEventSource methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 14:37'!
initialize
	super initialize! !

!FRPWhenEventSource methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/6/2009 14:39'!
recomputeOccurence
	eventSource event! !

FRPAbstractEventSource subclass: #FRPAnyButtonPressedEventSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPAnyButtonPressedEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/28/2008 18:15'!
recomputeOccurence
	| timer |
	timer := FRPScheduler currentScheduler timer.
	timer anyButtonPressed
		ifTrue: [occurence := true.
			Transcript show: 'bip']
		ifFalse: [occurence := nil]! !

FRPAbstractEventSource subclass: #FRPDefaultEventSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPDefaultEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 13:45'!
recomputeOccurence! !

FRPAbstractEventSource subclass: #FRPLeftButtonPressedEventSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPLeftButtonPressedEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/28/2008 18:14'!
recomputeOccurence
	Transcript show: 'I/O'.
	Sensor redButtonPressed
		ifTrue: [occurence := true]
		ifFalse: [occurence := nil]! !

FRPObject subclass: #FRPEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

FRPEvent subclass: #FRPObjectEvent
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPObjectEvent methodsFor: 'accessing' stamp: 'zz 5/28/2008 14:22'!
value
	^ value! !

FRPObject subclass: #FRPExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPExample classSide methodsFor: 'examples' stamp: 'zz 5/16/2008 15:54'!
example1
	"Just attach a watcher to a time instance"
	| time watcher |
	FRPScheduler initialize.
	time := FRPTime new.
	watcher := FRPWatcher new watch: time.
	time start! !

!FRPExample classSide methodsFor: 'examples' stamp: 'SergeStinckwich 8/3/2009 15:45'!
example2
	| time sinBehavior watcher |
	FRPScheduler initialize.
	time := FRPTime new.
	sinBehavior := time
				lift1: [:x | x sin * 100].
	watcher := FRPWatcher new watch: sinBehavior.
	time start! !

!FRPExample classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/19/2008 12:57'!
example3
	| eventSource anyButtonPressed time |
	self flag: #doesNotWork.
	FRPScheduler initialize.
	anyButtonPressed := FRPAnyButtonPressedEventSource new.
	eventSource := anyButtonPressed -=> Color red.
	time := FRPTime new.
	time start! !

!FRPObject methodsFor: 'events-registering' stamp: 'zz 5/16/2008 13:07'!
when: anEventSelector send: aMessageSelector to: anObject 
	self
		when: anEventSelector
		evaluate: (MessageSend receiver: anObject selector: aMessageSelector)! !

!FRPObject methodsFor: 'events-registering' stamp: 'zz 5/16/2008 13:07'!
when: anEventSelector send: aMessageSelector to: anObject with: anArg 
	self
		when: anEventSelector
		evaluate: (MessageSend
				receiver: anObject
				selector: aMessageSelector
				arguments: (Array with: anArg))! !

FRPObject subclass: #FRPScheduler
	instanceVariableNames: 'currentTimeStep numberCalls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

FRPScheduler class
	instanceVariableNames: 'currentScheduler'!

FRPScheduler class
	instanceVariableNames: 'currentScheduler'!

!FRPScheduler classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 11:13'!
currentScheduler
	"singleton"
	currentScheduler isNil
		ifTrue: [currentScheduler := FRPScheduler new].
	^ currentScheduler! !

!FRPScheduler classSide methodsFor: 'initialization' stamp: 'zz 5/20/2008 15:42'!
initialize
	super initialize.
	currentScheduler := nil! !

!FRPScheduler methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:55'!
beginInputStep
	numberCalls = 0
		ifTrue: [currentTimeStep := currentTimeStep + 1].
	numberCalls := numberCalls + 1! !

!FRPScheduler methodsFor: 'accessing' stamp: 'zz 5/14/2008 14:29'!
currentTimeStep
	^ currentTimeStep! !

!FRPScheduler methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 14:29'!
endInputStep
	numberCalls := numberCalls - 1! !

!FRPScheduler methodsFor: 'initialization' stamp: 'zz 5/19/2008 16:28'!
initialize
	super initialize.
	currentTimeStep := 0.
	numberCalls := 0! !

!FRPScheduler methodsFor: 'accessing' stamp: 'zz 5/28/2008 18:14'!
start
	self beginInputStep.
	self endInputStep! !

FRPObject subclass: #FRPWatcher
	instanceVariableNames: 'watch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP-Kernel'!

!FRPWatcher methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 8/3/2009 15:37'!
eventOccured
	Transcript show: 'Watcher: Behavior changed'; cr.! !

!FRPWatcher methodsFor: 'accessing' stamp: 'zz 5/28/2008 18:14'!
watch: aBehavior 
	watch := aBehavior.
	aBehavior
		when: #changedValue
		send: #eventOccured
		to: self! !

!Object methodsFor: '*FRP' stamp: 'zz 5/19/2008 14:29'!
asFRPConstantBehavior
	^ FRPConstantBehavior new initialBehaviorValue: self! !
FRPScheduler initialize!
